设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 565|回复: 8

[每日一码] 获取实体线型是BYLAYER的实际的线型

[复制链接]

已领礼包: 13个

财富等级: 恭喜发财

发表于 2017-2-15 12:15:56 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

x

How can I get the real linetype name of any entity (AcDbCurve) when the
linetype() function always return the "ByLayer" string?

Answer
If the linetype for an entity is BYLAYER, go to the layer on which the entity
resides and get the LINETYPELD for that layer. You can then open the linetype
TableRecord to get its name.

NOTE:  To determine if the linetype for an entity is set to BYLAYER, get the
object ID of the entity's linetype and compare it to the object ID that is
returned by the current database's byLayerLinetype() method.

This code shows how to do this:

游客,如果您要查看本帖隐藏内容请回复

 
// This is command 'GETLT'
void asdktestergetlt()
{
            AcDbObjectId objId;
            AcGePoint3d pick;
            AcDbEntity *pEnt = selectEntity( "\nSelect entity: ", objId, pick,
AcDb::kForRead );
            if ( NULL == pEnt )
                        return;
 
            if ( pEnt->linetypeId() == pEnt->database()->byLayerLinetype() )
            {
                        AcDbObject *pObj;
                        if ( Acad::eOk == acdbOpenAcDbObject( pObj, pEnt->layerId(),
AcDb::kForRead ))
                        {
                                    AcDbLayerTableRecord *pLayer =
AcDbLayerTableRecord::cast( pObj );
                                    if ( NULL != pLayer )
                                    {
                                                AcDbObject *pObj2;
                                                if ( Acad::eOk == acdbOpenAcDbObject( pObj2,
pLayer->linetypeObjectId(), AcDb::kForRead ))
                                                {
                                                            AcDbLinetypeTableRecord *pLinetype =
AcDbLinetypeTableRecord::cast( pObj2 );
                                                            if ( NULL != pLinetype )
                                                            {
                                                                        char *layerName, *linetypeName;
                                                                        pLayer->getName( layerName );
                                                                        pLinetype->getName( linetypeName
);
                                                                        acutPrintf( "\nEntity lives on
layer %s which uses linetype %s.", layerName, linetypeName );
                                                                        delete [] layerName;
                                                                        delete [] linetypeName;
                                                            }
                                                            pObj2->close();
                                                }
                                    }
                                    pObj->close();
                        }
            }
            pEnt->close();
}
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 2963个

财富等级: 家财万贯

发表于 2017-2-15 14:29:32 | 显示全部楼层
回复学习学习,谢谢
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2017-2-23 15:25:12 | 显示全部楼层
我也来学习学习,挺好的代码

论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 1741个

财富等级: 堆金积玉

发表于 2017-5-3 10:10:39 | 显示全部楼层
回帖学习

论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复

使用道具 举报

已领礼包: 28个

财富等级: 恭喜发财

发表于 2017-6-22 19:11:26 | 显示全部楼层
好资料,学习下
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2020-1-27 16:32:41 | 显示全部楼层
收藏了,谢谢
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2021-10-23 21:10:31 | 显示全部楼层
收藏了,谢谢
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2022-6-2 11:23:40 | 显示全部楼层
终于又找到这个插件了
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2022-8-18 15:03 , Processed in 0.174158 second(s), 30 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表